/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/
 
// Implementation of class Cmp3HttpRequester

#include "mp3_http_requester.h"
#include <zz_base64.h>
#include "mp3_source_config.h"

// Construction
Cmp3HttpRequester::Cmp3HttpRequester( void )
: CzzHTTP( Cmp3SourceConfig::getServerHost().c_str(), Cmp3SourceConfig::getServerPort().c_str(), "myMusic", 3, 3 ), m_Log( Cmp3SourceConfig::appName().c_str() )
{

}

// Destruction
Cmp3HttpRequester::~Cmp3HttpRequester()
{

}

void Cmp3HttpRequester::updateSong( const CzzString& usr, const char* song )
{
	try
	{
		CzzString data = CzzString::Format( "%s:%s", Cmp3SourceConfig::getAdminUser().c_str(), Cmp3SourceConfig::getAdminPwd().c_str() );
		char dst[76];
		unsigned char src[76];
		strcpy( (char*)src, data.c_str() );
		int r = CzzBase64::encode( dst, 76, src, strlen((char*)src) );
		CzzString url = CzzString::Format( Cmp3SourceConfig::getServerMetadataUrl().c_str(), usr.c_str(), song );
		m_ResponseFile = "";

		// Request
		addRequest( "GET", url.c_str() );
		
		// Headers
		addHeader( "Host: %s", m_LocalHost.c_str() );
		addHeader( "User-Agent: libzzinet/1.0 (%s)", m_UserAgent.c_str() );
		addHeader( "Accept: %s", "application/vnd.ms-excel, application/msword, application/vnd.ms-powerpoint, image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*" );
		addHeader( "Connection: %s", "close" );
		addHeader( "Authorization: Basic %s", dst );
		addEndMarker();

		m_Log.Print( _DEBUGPARAMS, "Updating server with META-INFO: %s", song );

		send();

		delete m_SendBuffer;
		m_SendBuffer = NULL;

		reply();
	}
	catch( ... )
	{
		m_Log.Print( _WARNINGPARAMS, "Could'nt update META-INFO: %s", song );
	}
}