/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/
 
/**
	Tar emot inkommande kommandon fr att styra
	spellistan

	Toni Thomsson, toni@tonjac.org
*/

#ifndef mp3_playlist_handler_h
#define mp3_playlist_handler_h

#include <zz_http_server.h>
#include <zz_win_thread.h>
#include "mp3_playlist.h"
#include <map>

class Cmp3PlayListHandler : public CzzWinThread, CzzHTTPServer
{
public:

	//* Construction
	Cmp3PlayListHandler( void );
	virtual ~Cmp3PlayListHandler();

	virtual void OnStart( void );

	Cmp3PlayList* getPlayList( const CzzString& usr );
	map<CzzString, Cmp3PlayList* >* getPlayLists( void );

protected:
private:

	// Listen for a request
    int listen( void );

	 // Errors
    int serviceNotFound( CzzHTTPRequest* req );
    int internalError( CzzHTTPRequest* req, const char* msg );

	int addSong( const CzzString& usr, CzzHTTPRequest* req, const char* name, const char* album, const char* song );
    int clear( const CzzString& usr, CzzHTTPRequest* req );
	int randomize( const CzzString& usr, CzzHTTPRequest* req );
	int list( const CzzString& usr, CzzHTTPRequest* req );
	int replacePlaylist( const CzzString& usr, CzzHTTPRequest* req, const char* name );
	int listIndexes( const CzzString& usr, CzzHTTPRequest* req );
	int forward( const CzzString& usr, CzzHTTPRequest* req );
	int reverse( const CzzString& usr, CzzHTTPRequest* req );
	int removeSong( const CzzString& usr, CzzHTTPRequest* req, const char* name, const char* album, const char* song );
	int nowPlaying( const CzzString& usr, CzzHTTPRequest* req );
	int commingUp( const CzzString& usr, CzzHTTPRequest* req );
	int lastPlayed( const CzzString& usr, CzzHTTPRequest* req );

    CzzLog m_Log;
	map<CzzString, Cmp3PlayList* > m_PlayLists;

};

#endif // mp3_playlist_handler_h