/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3ErrorData

#include "mp3_error_data.h"
#include "mp3_svc.h"

// Construction
Cmp3ErrorData::Cmp3ErrorData( const CzzString& msg )
 : CzzDataService( "getErrorData" ), m_Msg(msg)
{

}

// Destruction
Cmp3ErrorData::~Cmp3ErrorData()
{

}

CzzDataServiceReply* Cmp3ErrorData::execute( void* session, CzzParameterMap* req )
{

	CzzDataService::execute( session, req );

	CzzDataServiceReply* reply = new CzzDataServiceReply();


	reply->addField( MP3_FLD_ERROR, m_Msg );

	return reply;
}

int Cmp3ErrorData::size()
{
    return sizeof(Cmp3ErrorData);
}