/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

/**
	HTML file reader/dumper

	Toni Thomsson, toni@tonjac.org
*/

#ifndef mp3_html_file_h
#define mp3_html_file_h

#include <zz_string.h>
#include <map>

#ifdef WIN32
	using namespace std;
#endif

typedef map<short, CzzString > Cmp3ItemList;

// The class
class Cmp3HtmlFile
{
public:

	//* Construction
	Cmp3HtmlFile( const char* file );
	~Cmp3HtmlFile();

	// Print file
	void print( int d, ... );

	// Create a HTML-encoded string for filling a combobox with items
	CzzString createComboBoxItemString( Cmp3ItemList& list );


private:
	void readFile( void );
	
	CzzString m_Buffer;
	CzzString m_File;
};


#endif // mp3_html_file_h

