/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

/**
	HTML service manager

	Toni Thomsson, toni@tonjac.org
*/

#ifndef mp3_html_service_manager_h
#define mp3_html_service_manager_h

#include <zz_log_exception.h>
#include <zz_cgi.h>

#include "mp3_html_file.h"
#include "mp3_svc.h"
#include "mp3_config.h"
#include <mp3_list.h>

// The class
class Cmp3HtmlServiceManager
{
public:

	//* Construction
	Cmp3HtmlServiceManager( const CzzString& );
	~Cmp3HtmlServiceManager();

	// Execute service call
	void execute( void );

private:

	CzzString getUser( void );
	CzzString getIP( void );

	// Parse cmd
	void parseCmd( void );
	void checkAdmin( void );
	void checkLicense( void );
	void checkIP( void );

	CzzCGI m_CGI;
	CzzLog m_Log;
	CzzString m_Session;
	CzzString m_User;
	CzzString m_IP;
};

#endif // mp3_html_service_manager_h




