/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3ListItem

#include "mp3_list_item.h"

// Construction
Cmp3ListItem::Cmp3ListItem( void )
 : m_Time(0), m_Name()
{

}
Cmp3ListItem::Cmp3ListItem( long time, CzzString name, CzzString album )
 : m_Time(time), m_Name(name), m_Album(album)
{

}

Cmp3ListItem::Cmp3ListItem( long time, CzzString name )
 : m_Time(time), m_Name(name), m_Album()
{

}

Cmp3ListItem::Cmp3ListItem( const Cmp3ListItem& copy )
 : m_Time( copy.getTime() ), m_Name( copy.getName() ), m_Album( copy.getAlbum() )
{

}

// Destruction
Cmp3ListItem::~Cmp3ListItem()
{

}

CzzString Cmp3ListItem::getName(void) const
{
	return m_Name;
}

CzzString Cmp3ListItem::getAlbum(void) const
{
	return m_Album;
}

long Cmp3ListItem::getTime(void) const
{
	return m_Time;
}

bool Cmp3ListItem::operator()( Cmp3ListItem* a, Cmp3ListItem* b )	
{
	return a->getTime() > b->getTime(); 
}


