/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3RadioListData

#include "mp3_radio_list_data.h"
#include "mp3_svc.h"
#include "mp3_config.h"

#include <time.h>
#include <sys/timeb.h>
#include <sys/types.h> 
#include <id3/tag.h>
#include <zz_file.h>
#include <winver.h>

// Construction
Cmp3RadioListData::Cmp3RadioListData( void )
 : CzzDataService( "listRadioData" )
{

}

// Destruction
Cmp3RadioListData::~Cmp3RadioListData()
{

}

CzzDataServiceReply* Cmp3RadioListData::execute( void* session, CzzParameterMap* req )
{
	CzzDataService::execute( session, req );

	CzzDataServiceReply* reply = new CzzDataServiceReply();

	reply->addFieldName( MP3_FLD_LIST_ART );
	reply->addFieldName( MP3_FLD_TITLE_ROW );
	reply->addFieldName( MP3_FLD_INFO_ROW );
	reply->addFieldName( MP3_FLD_TITLE_LINK );
	reply->addFieldName( MP3_FLD_PLAY_LINK );


	long handle = 0;
	int error = 0;
	int result = 0;
	_finddata_t finfo;
	CzzString path = Cmp3Config::getRadioDir();
	CzzString subdir;
	
	// Find first file
	handle = _findfirst( (path + "\\*.m3u").c_str(), &finfo );

	// Read the dir
	if( (handle!= ENOENT)  && (handle != EINVAL) && (handle != -1) )
	{
		while( !error )
		{
			// We're not interested in the . and .. 
			if( (stricmp( finfo.name, "." ) != 0) && (stricmp( finfo.name, ".." ) != 0) )
			{
				// Is it a subdir?
				if( !(finfo.attrib & _A_SUBDIR) && !(finfo.attrib & _A_SYSTEM) )
				{
					CzzString pl = finfo.name;
					pl = pl.substr(0,strlen(finfo.name)-4);

					reply->addFieldValue( "radio.jpg" );
					reply->addFieldValue( pl );
					reply->addFieldValue( "net-radio" );
					reply->addFieldValue( CzzString::Format( 
						"%s/mp3_playlist.exe?svc=5&name=%s", 
						Cmp3Config::getCGIDir().c_str(), finfo.name ) );
					reply->addFieldValue( CzzString::Format( 
						"%s/mp3_playlist.exe?svc=5&name=%s", 
						Cmp3Config::getCGIDir().c_str(), finfo.name ) );
				}
			}

			// Next file
			error = _findnext( handle, &finfo );
		}
	}

	_findclose( handle );

	return reply;
}

int Cmp3RadioListData::size()
{
    return sizeof(Cmp3RadioListData);
}
