/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

/**
	MP3 Services
	Toni Thomsson, toni@tonjac.org
*/

#ifndef mp3_svc_h
#define mp3_svc_h

// Services
typedef enum
{

	MP3_SVC_FRAMES = 0,
	MP3_SVC_TOP = 1,
	MP3_SVC_LEFT = 2,

	MP3_SVC_LIST_ARTISTS = 3,
	MP3_SVC_LIST_RECORDS = 4,
	MP3_SVC_LIST_SONGS = 5,
	MP3_SVC_LIST_M3U = 6,
	MP3_SVC_LIST_M3U_CONTENTS = 7,
	MP3_SVC_LIST_SEEK = 8,
	MP3_SVC_LIST_RADIO = 9,

	MP3_SVC_LIST_M3U_DELETE = 10,
	MP3_SVC_LIST_M3U_SAVE = 11,
	MP3_SVC_LIST_M3U_ADD = 12,
	MP3_SVC_LIST_M3U_REMOVE = 13,

	MP3_SVC_LIST_RADIO_ADD = 22,
	MP3_SVC_LIST_MYRADIO = 23,
	MP3_SVC_LIST_RADIO_REMOVE = 24,
	MP3_SVC_LIST_RADIO_FORWARD = 25,
	MP3_SVC_LIST_RADIO_REVERSE = 26,
	MP3_SVC_LIST_RADIO_REPLACE = 27,
	MP3_SVC_LIST_RADIO_ADD_RECORD = 28,
	MP3_SVC_LIST_RADIO_CLEAR = 29,
	MP3_SVC_LIST_RADIO_RAND = 30,
	
	MP3_SVC_LIST_INFO = 96,
	MP3_SVC_LIST_CHANGE_SKIN_FORM = 97,
	MP3_SVC_LIST_CHANGE_SKIN = 98,
	MP3_SVC_LIST_LATEST = 99,
	MP3_SVC_HELP = 100,

} MP3_SVC_IDX;

// Fields
#define MP3_FLD_IP "ip"
#define MP3_FLD_USER "user"
#define MP3_FLD_SID "sid"
#define MP3_FLD_COPYRIGHT "copyright"
#define MP3_FLD_TITLE "title"
#define MP3_FLD_HEADLINE "headline"
#define MP3_FLD_VERSION "version"
#define MP3_FLD_LANG "lang"
#define MP3_FLD_SKIN "skin"
#define MP3_FLD_TABLE "table"
#define MP3_FLD_LIST_ART "ListArt"
#define MP3_FLD_BACK_URL "BackURL"
#define MP3_FLD_ALBUM_TITLE "AlbumTitle"
#define MP3_FLD_YEAR "Year"
#define MP3_FLD_BITRATE "Bitrate"
#define MP3_FLD_SONG_TITLE "SongTitle"
#define MP3_FLD_SONG_LENGTH "SongLength"
#define MP3_FLD_SONG_ORDER "SongOrder"
#define MP3_FLD_RADIO_LATEST_ADDED "RadioLatestAdded"
#define MP3_FLD_RADIO_NOW_PLAYING "NowPlaying"
#define MP3_FLD_RADIO_COMMING_UP "CommingUp"
#define MP3_FLD_M3U_LATEST_ADDED "PlaylistLatestAdded"
#define MP3_FLD_M3U_NO "No"
#define MP3_FLD_M3U_TIME "Time"
#define MP3_FLD_M3U_SIZE "Size"
#define MP3_FLD_TITLE_ROW "TitleRow"
#define MP3_FLD_INFO_ROW "InfoRow"
#define MP3_FLD_TITLE_LINK "TitleLink"
#define MP3_FLD_INFO_LINK "InfoLink"
#define MP3_FLD_PLAY_LINK "PlayLink"
#define MP3_FLD_SEEK_LINK "SeekLink"
#define MP3_FLD_RAND_LINK "Randomize"
#define MP3_FLD_SAVE_LINK "SaveLink"
#define MP3_FLD_SKIP_FORWARD "SkipForward"
#define MP3_FLD_SKIP_BACKWARD "SkipBackward"
#define MP3_FLD_PLAY_SONG "PlaySong"
#define MP3_FLD_ARTIST "Artist"
#define MP3_FLD_RADIO_NAME "LocalName"
#define MP3_FLD_ADD_SONG_TO_PLAY_LIST "AddSongToPlaylist"
#define MP3_FLD_ADD_SONG_TO_RADIO "AddSongToRadio"
#define MP3_FLD_ADD_PLAYLIST_TO_RADIO "AddPlaylistToRadio"
#define MP3_FLD_ADD_ALBUM_TO_RADIO "AddAlbumToRadio"
#define MP3_FLD_RADIO_EMPTY "ClearRadio"
#define MP3_FLD_EMPTY_LINK "EmptyLink"
#define MP3_FLD_REMOVE_SONG "RemoveSong"
#define MP3_FLD_LIST_RECORD "ListRecord"
#define MP3_FLD_LIST_PLAYLISTS "ListPlaylists"
#define MP3_FLD_LIST_PLAYLIST "ListPlaylist"
#define MP3_FLD_LIST_MYRADIO "ListMyRadio"
#define MP3_FLD_LIST_CHANNELS "ListChannels"
#define MP3_FLD_LIST_LATEST "ListLatestAdded"
#define MP3_FLD_HELP "Help"
#define MP3_FLD_HELP_HTML "helpHTML"
#define MP3_FLD_ERROR "ErrorMessage"
#define MP3_FLD_SEEK_SVC "SeekSvc"
#define MP3_FLD_SEEK_LINK "SeekLink"
#define MP3_FLD_VER_NAME "CompName"
#define MP3_FLD_VER_VER "CompVersion"
#define MP3_FLD_NO_ALBUMS "NoAlbums"
#define MP3_FLD_NO_ARTISTS "NoArtists"
#define MP3_FLD_NO_SONGS "NoSongs"
#define MP3_FLD_RAND_RADIO_LINK "RandRadio"

#define MP3_FLD_RENDER_TOP "RenderTopFrame"
#define MP3_FLD_RENDER_LEFT "RenderLeftFrame"
#define MP3_FLD_RENDER_MAIN "RenderMainFrame"

#define MP3_CGI_PAR_INDEX "anchor"
#define MP3_CGI_PAR_NAME "name"
#define MP3_CGI_PAR_ALBUM "album"

#endif // mp3_svc_h


