/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3VersionListData

#include "mp3_version_list_data.h"
#include "mp3_svc.h"

// Construction
Cmp3VersionListData::Cmp3VersionListData( void )
 : CzzDataService( "listVersionData" )
{

}

// Destruction
Cmp3VersionListData::~Cmp3VersionListData()
{

}

CzzDataServiceReply* Cmp3VersionListData::execute( void* session, CzzParameterMap* req )
{

	CzzDataService::execute( session, req );

	CzzDataServiceReply* reply = new CzzDataServiceReply();

	reply->addFieldName( MP3_FLD_VER_NAME );
	reply->addFieldName( MP3_FLD_VER_VER);
	

	reply->addFieldValue( "myMusic" );
	reply->addFieldValue( "2.1" );

	reply->addFieldValue( "mp3_gui.exe" );
	reply->addFieldValue( getVersion( ".\\mp3_gui.exe" ) );

	reply->addFieldValue( "mp3_playlist.exe" );
	reply->addFieldValue( getVersion( ".\\mp3_playlist.exe" ) );

	reply->addFieldValue( "mp3_webserver.exe" );
	reply->addFieldValue( getVersion( "..\\mp3_webserver.exe" ) );

	reply->addFieldValue( "mp3_config.exe" );
	reply->addFieldValue( getVersion( "..\\mp3_config.exe" ) );

	reply->addFieldValue( "mp3_stream.exe" );
	reply->addFieldValue( getVersion( "..\\stream\\server\\mp3_stream.exe" ) );

	reply->addFieldValue( "mp3_source.exe" );
	reply->addFieldValue( getVersion( "..\\stream\\source\\mp3_source.exe" ) );

	return reply;
}

CzzString Cmp3VersionListData::getVersion( const char* component ) 
{
	VS_FIXEDFILEINFO* ver = NULL;
	char* data = NULL;
	char version[256];
	char* desc = NULL;
	static char VER_FORMAT[] = "%d.%02d.%04d";
	DWORD size = 0;
	DWORD d = 0;
	DWORD* str = NULL;
	UINT vs = 0;

	sprintf( version, VER_FORMAT,
							HIWORD(0),
							HIWORD(0),
							LOWORD(0) );

	size = GetFileVersionInfoSize( (char*)component, &d );

	if( size )
	{
		data = new char[ size+1 ];

		if( GetFileVersionInfo( (char*)component, 0, size, data ) )
		{
			vs = 256;

			// Version resource
			if( VerQueryValue( data, TEXT( "\\" ), (void**)&ver, &vs ) )
			{
				sprintf( version, VER_FORMAT,
							HIWORD(ver->dwFileVersionMS),
							LOWORD(ver->dwFileVersionMS),
							LOWORD(ver->dwFileVersionLS) );
			}

			vs = 256;
		}

		delete data;
	}

	return CzzString( version );
}

int Cmp3VersionListData::size()
{
    return sizeof(Cmp3VersionListData);
}
