/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3List

#include <limits.h> 
#include "mp3_list.h"

// Construction
Cmp3List::Cmp3List( void ) : m_Size(0), m_List(), m_Time()
{

}

// Destruction
Cmp3List::~Cmp3List()
{

}

int Cmp3List::size( void )
{
	return m_List.size();
}

void Cmp3List::add( const char* item )
{
	m_List[ m_List.size() ] = new CzzString(item);
}

void Cmp3List::add( const char* item, long time )
{
	long early = LONG_MAX;
	long j = 0;
	long k = 0;
	bool found = false;
	

	if( m_Time.size() == 20 )
	{
		for( int i = 0; i < m_Time.size(); i++ )
		{
			if( m_Time[i] < early )
			{
				k = i;
				early = m_Time[i];
			}

			if( time > m_Time[i] && !found )
			{
				found = true;
				j = i;
			}
			else if( found && (time > m_Time[i]) && (m_Time[i] > m_Time[j]) )
				j = i;
		}

		if( found )
		{
			m_List[k] = m_List[j];
			m_Time[k] = m_Time[j];
			m_List[j] = new CzzString(item);
			m_Time[j] = time;
		}
	}
	else
	{
		m_List[ m_List.size() ] = new CzzString(item);
		m_Time[ m_Time.size() ] = time;
	}
}

CzzString* Cmp3List::get( int pos )
{

	return m_List[pos];
}

long Cmp3List::getTime( int pos )
{

	return m_Time[pos];
}
