/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/
 
// Implementation of class Cmp3NtWebService

#include "mp3_nt_webservice.h"
#include "mp3_dyndns.h"

CzzString Cmp3NtWebService::m_Home;

// Construction
Cmp3NtWebService::Cmp3NtWebService( const CzzString& home )
 : CzzNTService( WEB_SVC_NAME, WEB_SVC_NAME
  , "", WEB_SVC_NAME, "", WEB_SVC_DESCRIPTION, SERVICE_AUTO_START ), m_Server( NULL ),
  m_AccessLog( NULL ), m_Config()
{
	if( m_Config.getDoAcessLog() )
		m_AccessLog = new CzzAccessLog( m_Config.getAccessLog().c_str() );
}

// Destruction
Cmp3NtWebService::~Cmp3NtWebService()
{
	if( m_Server )
	{
		m_Server->Stop( true, 0 );
		delete m_Server;
	}

	if( m_AccessLog )
		delete m_AccessLog;
}

// Starts the jobs
void Cmp3NtWebService::StartJobs( void )
{
	Cmp3HttpServer* m_Server = new Cmp3HttpServer( m_AccessLog );
	m_Server->Run();

    updateRegistry();
}


void Cmp3NtWebService::updateRegistry( void )
{
    try 
    {
#ifdef _DEBUG
	    Cmp3Dyndns dyndns( "localhost" );
#else
    	Cmp3Dyndns dyndns( "checkip.dyndns.org" );
#endif
        CzzString ip = dyndns.getPublicIP();
        CzzString port = Cmp3WebConfig::getListenPort();
#ifdef _DEBUG
	    Cmp3Dyndns tonjac( "localhost" );
#else
	    Cmp3Dyndns tonjac( "www.tonjac.org" );
#endif
        tonjac.registerUse( ip, port );
    }
    catch( ... ) {}
}

void Cmp3NtWebService::OnStart( int argc, char** argv )
{

	DWORD wait;
	
	Init();

	// Start worker threads
	StartJobs();
	
	// Default impl. does nothing just loops and waits for stop signal
	while( 1 )
	{
		wait = WaitForSingleObject( m_StopEvent, INFINITE );
		if( wait == WAIT_OBJECT_0 )
			break;

	}
	
	Exit();
}


