/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/
 
// Implementation of class Cmp3WebConfig

#include "mp3_nt_webservice.h"
#include "mp3_web_config.h"

Cmp3ThreadSafeConfig* Cmp3WebConfig::m_Config = NULL;

// Construction
Cmp3WebConfig::Cmp3WebConfig( void )
{
	if( Cmp3WebConfig::m_Config == NULL )
		Cmp3WebConfig::m_Config = new Cmp3ThreadSafeConfig( Cmp3NtWebService::m_Home + "\\" + Cmp3WebConfig::appName() + ".ini" );
}

// Destruction
Cmp3WebConfig::~Cmp3WebConfig()
{
	if( Cmp3WebConfig::m_Config != NULL )
		delete Cmp3WebConfig::m_Config;
}

CzzString Cmp3WebConfig::getDocumentRoot( )
{
	return m_Config->getEntry( Cmp3WebConfig::appName(), "document_root" );
}

CzzString Cmp3WebConfig::getListenPort( )
{
	return m_Config->getEntry( Cmp3WebConfig::appName(), "listen_port" );
}

CzzString Cmp3WebConfig::getLang( void )
{
	return m_Config->getEntry( Cmp3WebConfig::appName(), "lang" );
}

CzzString Cmp3WebConfig::getSkin( void )
{
	return m_Config->getEntry( Cmp3WebConfig::appName(), "skin" );
}

CzzString Cmp3WebConfig::getUserPwd( const CzzString& usr )
{
	return m_Config->getEntry( "users", usr );
}

CzzString Cmp3WebConfig::getAlias( const CzzString& alias )
{
	return m_Config->getEntry( "alias", alias );
}

CzzString Cmp3WebConfig::appName( void )
{
	return "mp3_webserver";
}

CzzString Cmp3WebConfig::getAccessLog( void )
{
	return m_Config->getEntry( Cmp3WebConfig::appName(), "accesslog" );
}

bool Cmp3WebConfig::getDoAcessLog( void )
{
	if( m_Config->getEntry( Cmp3WebConfig::appName(), "log" ) == "1" )
		return true;
	else
		return false;
}
