/* libzzinet
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2000-2006, Toni Thomsson <toni@tonjac.org> 
*/

/**
	Abstraction of output from a CGI-program

	Toni Thomsson, toni@tonjac.org
*/

#ifndef zz_cgi_output_h
#define zz_cgi_output_h

#include <zz_string.h>

class ZZ_API CzzCGIOutput
{
public:

	//* Construction
	CzzCGIOutput( void );
	CzzCGIOutput( bool StdOut );
	CzzCGIOutput( bool StdOut, const CzzString& output );
	virtual ~CzzCGIOutput();

	void append( const CzzString& add );
	int size( void );

	char* allocReply( void );
	static char* freeReply( char* buff );

protected:
private:
	bool m_Stdout;
	CzzString m_Output;

};

#endif // zz_cgi_output_h