/* libzz
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2000-2006, Toni Thomsson <toni@tonjac.org> 
*/

#ifndef zz_console_application_h
#define zz_console_application_h

#include <zz_application.h>
#include <zz_export.h>

/**
	Console application

	@author Toni Thomsson, toni@tonjac.org
    @see CzzApplication
*/
class ZZ_API CzzConsoleApplication : public CzzApplication
{
public:

	/** 
        Creates a console application

        @param name Name used to configure logging
    */
	CzzConsoleApplication( const CzzString& name );
	virtual ~CzzConsoleApplication();

	/** 
        Access the single application object
    */
	static CzzConsoleApplication* getInstance( void );
};

#endif // zz_console_application_h

